# Settings
%global product_name Data warehouse package for oVirt Virtualization Suite
%global product_description oVirt virtualization manager data warehouse
%global install_poms 0

%global dwh_name ovirt-engine-dwh
%global dwh_java %{_javadir}/%{dwh_name}

%global make_common_opts \\\
        -j1 \\\
        PACKAGE_NAME=%{name} \\\
        OVIRT_DWH_NAME=%{dwh_name} \\\
        PREFIX=%{_prefix} \\\
        SYSCONF_DIR=%{_sysconfdir} \\\
        BIN_DIR=%{_bindir} \\\
        DATAROOT_DIR=%{_datadir} \\\
        PYTHON=%{__python} \\\
        PYTHON_DIR=%{python_sitelib} \\\
        JAVA_DIR=%{_javadir} \\\
        MAVENPOM_DIR=%{_mavenpomdir} \\\
        PKG_JAVA_DIR=%{dwh_java} \\\
        %{?BUILD_FLAGS:BUILD_FLAGS="%{BUILD_FLAGS}"} \\\
        %{?EXTRA_BUILD_FLAGS:EXTRA_BUILD_FLAGS="%{EXTRA_BUILD_FLAGS}"}

Name: rhevm-dwh
Version: 3.1.3
Release: 2%{?dist}
License: GPLv2
Summary: %{product_name}
Group: Virtualization/Management
URL: http://www.ovirt.org
BuildArch: noarch

# We build RHEV-M in the MEAD environment, and that means that the
# sources are the artifacts previously built with maven:

Source0: ovirt_engine_dwh-root-3.1.3-sources.zip
Source1: packaging-3.1.3.pom
Source2: advancedPersistentLookupLib-1.0.jar
Source3: advancedPersistentLookupLib-1.0.pom
Source4: root-3.1.3.pom
Source5: etl_sources-3.1.3.pom
Source6: historyETLProcedure-3.1.3.jar
Source7: historyETLProcedure-3.1.3.pom
Source8: data-warehouse-3.1.3.pom
Source9: talendRoutines-5.1.1.r84309.jar
Source10: talendRoutines-5.1.1.r84309.pom
Source11: history_etl-3.1.3.pom

BuildRequires: jpackage-utils
BuildRequires: make
BuildRequires: log4j
BuildRequires: postgresql-jdbc
Requires: python
Requires: jakarta-commons-collections >= 3.2
Requires: java-1.7.0-openjdk
Requires: jpackage-utils
Requires: log4j
Requires: dom4j >= 1.6.1
Requires: postgresql-jdbc
Requires: postgresql-server >= 8.4.7
Requires: postgresql-contrib >= 8.4.7
Requires: logrotate
Requires: rhevm >= 3.1.0

%description
The %{product_description} package provides
the ETL process and DB scripts to create a historic database API.
Enables SQL BI reports creation for management and monitoring.

%prep

# Note that MEAD takes the name used here (after the -n option)
# from the name of the source code repository, so if you decide to
# name your repository "whatever.git" you will also need to change
# here to "-n whatever":

%setup -q -T -b 0 -n rhevm-dwh

%build

# Everything has been built previously by maven, so nothing else
# to do here.

%install
rm -fr "%{buildroot}"

# Use the makefile to do the normal installation, after that we
# will need to replace jar files with links to their actual
# locations:
make %{make_common_opts} install_without_maven MAVEN_OUTPUT_DIR=%{_sourcedir} DESTDIR=%{buildroot} RPM_RELEASE_VERSION=%{release}

install -d %{buildroot}%{_initddir}
install -p -m 755 data-warehouse/history_etl/history_service/%{dwh_name}d %{buildroot}%{_initddir}
ln -s -f %{_bindir}/%{dwh_name}-setup %{buildroot}%{_bindir}/%{name}-setup

# Needed for compatibility if package is different than the directory structure
%if "%{name}" != "%{dwh_name}"
ln -s "%{dwh_name}" "%{buildroot}%{dwh_java}/../%{name}"
%endif

# Register poms
%if !%{install_poms}
rm -fr "%{buildroot}%{_mavenpomdir}"
%else
for pom in %{buildroot}%{_mavenpomdir}/*.pom
do
  pomdir=`dirname "${pom}"`
  pom=`basename "${pom}"`
  jpppom="JPP.${pom}"
  mv "${pomdir}/${pom}" "${pomdir}/${jpppom}"
  artifact_id=`echo "${pom}" | sed -e 's/^%{name}-//' -e 's/\.pom//'`
  if [ -f "%{buildroot}%{dwh_java}/${artifact_id}.jar" ]
  then
    %add_maven_depmap "${jpppom}" "%{name}/${artifact_id}.jar"
  else
    %add_maven_depmap "${jpppom}"
  fi
done
%endif

%post
/sbin/chkconfig --add %{dwh_name}d > /dev/null 2>&1
/sbin/chkconfig %{dwh_name}d off > /dev/null 2>&1
/sbin/service %{dwh_name}d stop > /dev/null 2>&1
/usr/sbin/logrotate /etc/logrotate.conf > /dev/null || /bin/true

%preun
if [ "$1" -eq 0 ]
then
    /sbin/service %{dwh_name}d stop > /dev/null 2>&1
    /sbin/chkconfig --list %{dwh_name}d > /dev/null 2>&1
    if [ $? -eq 0 ]
    then
        /sbin/chkconfig --del %{dwh_name}d > /dev/null 2>&1
    fi
fi

%files
%{dwh_java}
%{_datadir}/%{dwh_name}
%if "%{name}" != "%{dwh_name}"
%{_javadir}/%{name}
%endif
%if %{install_poms}
%{_mavendepmapfragdir}/%{name}
%{_mavenpomdir}/JPP.%{name}-*
%endif

%dir %{_sysconfdir}/ovirt-engine/%{dwh_name}
%{_initddir}/%{dwh_name}d
%config(noreplace) %{_sysconfdir}/logrotate.d/%{dwh_name}d
%{_bindir}/%{dwh_name}-setup
%{_bindir}/rhevm-dwh-setup
%{_sysconfdir}/cron.hourly/ovirt_engine_dwh_watchdog.cron
%config(noreplace) %{_sysconfdir}/ovirt-engine/%{dwh_name}/Default.properties

%changelog
* Tue Mar 05 2013 Yaniv Dary <ydary@redhat.com> - 3.1.3
Fixed bug:
916643 - [rhevm] - Upgrade - ovirt-engine-dwhd fails start automatically after upgrade (Upgrade from si25.4 to si27.1)

* Tue Feb 12 2013 Yaniv Dary <ydary@redhat.com> - 3.1.3
Fixed bug:
907434 - [rhevm-dwh][upgrade] - the upgrade of DWH succeeds but dwh fails to perform aggregation

* Thu Nov 15 2012 Yaniv Dary <ydary@redhat.com> - 3.1.0
Fixed bugs:
876227 - [rhevm-dwh] - upgrade - dwh upgrade doesn't rename the old DB
876240 - [rhevm-dwh] - upgrade - Reports doesnt work after upgrade (IC is empty and reports doesnt execute)
876242 - [rhevm-dwh] - upgrade - dwh service fails to start (java.lang.ClassNotFoundException:)

* Sun Nov 04 2012 Yaniv Dary <ydary@redhat.com> - 3.1.0
Updated DWH ENUM localization

* Tue Oct 23 2012 Yaniv Dary <ydary@redhat.com> - 3.1.0
Bugs fixed:
800372 - vm system cpu usage is always 0.
840866 - [rhevm-dwh] - History DB - View v3_1_host_hourly_history_view shows 61 minutes instead of 60 minutes (Column minutes_in_status)
866492 - [rhevm-dwh] - Duplicate rows in Views


* Tue Oct 09 2012 Yaniv Dary <ydary@redhat.com> - 3.1.0
- Added upgrade flow from 3.0 to 3.1.
- The host mac address field is extended to 59 so it could store
  InfiniBand HCA mac address.

Bugs Fixed:
823397 - Extend host mac address to support IB HCA
858569 - Replace JBoss service name with ovirt-engine

* Tue Sep 04 2012 Yaniv Dary <ydary@redhat.com> - 3.1.0
Bugs Fixed:
841217  - [rhevm-dwh] - History DB - Incorrect column name fqn_or_ip in View v3_1_host_configuration_view

* Tue Aug 28 2012 Yaniv Dary <ydary@redhat.com> - 3.1.0
Bugs Fixed:
851833  - [ovirt-dwh] - ETL - Fails to connect to oVirt Engine Portal

* Tue Aug 21 2012 Yaniv Dary <ydary@redhat.com> - 3.1.0
Package was renamed to rhevm-dwh.
Paths are all the same and added symlink to branded setup (rhevm-dwh-setup).

Bugs Fixed:
850330 - Setup fails on missing file
781979 - ETL copies the templates images as disks
844667 - Remote DB - DWH Setup fails to upgrade remote history DB
845024 - ovirt-engine-dwh packaging - inconsistent with other rhevm components.

* Mon Jul 16 2012 Yaniv Dary <ydary@redhat.com> - 3.1.0
bug fixed:
838292 - logrotate - DWH Log is not log-rotating correctly
840273 - Views v3_x_vm_disk_samples_history_view are empty
840283 - Views v3_x_vm_device_history_view are empty

* Wed Jul 04 2012 Yaniv Dary <ydary@redhat.com> - 3.1.0
bug fixed:
834869 - Installer - Failed to create history DB

* Thu Apr 20 2012 Yaniv Dary <ydary@redhat.com> - 3.1.0
Changed from rhevm-reports-dwh 3.0 release:
- Project was renamed to ovirt-engine-dwh
- DB was renamed to ovirt_engine_history
- Added 3.1 API views.
- Added vm devices history (deprecated vm disks map).
- Added floating disks history.
- Added engine up status check. Samples only collected when engine is up.
- Added pushing audit log events in case of etl start\stop and error.
- Added a watch dog.
- Added new columns to the API.

bugs fixed:
728768  - [History] - Missing ENUM values for USB policy in vm configuration.
755865  - [rhevm-reports] - Ad Hoc - missing enum for "VM disk storage type" (3) in report
756405  - 'rhevm-dwh-setup' command support in 'ja_JP-UTF-8' environment
766636  - [rhevm-reports] - rhevm-etl - postgreSQL locks the CPU on 100%
768721  - [rhevm-reports] Need to update ETL generated code.
768755  - ETL copies duplicate entries of all hosts every hour.
770644  - history: Unable to create a database with a MINUS sign in its name
781470  - Stored Procedure dbo.dwh_history_aggregate_level fails to execute successfully
781979  - [rhevm-reports] - ETL copies the templates images as disks
783197  - [rhevm-reports] - When moving the database from one time zone to another many reports stop working.
oVirt bugs that a fix is inculded for:
817519  - [ovirt-dwh] - jbossas cannot start (ETL occupies port 8080)
772925  - RFE - ETL service start/stop should be logged in oVirt event log and send a notification by mail
772916  - RFE - ovirt-etl should have a WatchDog
770679  - [ovirt-dwh] - Cannot Create the ovirt_history database using the create_db.sh script
749664  - Store number of CPU sockets
749663  - Store CPU speed in Megahertz
817756  - [ovirt-dwh] - oVirt-ETL log should be under /var/log/ovirt-engine
783787  - [ovirt-etl] - Sample History - Saves data in host_samples_history_table/View for more then 48H
